use datawind
if exists (select name from sysobjects
   where name='find_known_sim_proc' and type='P')
   drop procedure find_known_sim_proc

go 
use datawind
go


CREATE PROCEDURE find_known_sim_proc
@sim  varchar(255),
@tolerance float,
@difference float

as

--select startyear, startmonth, total_mb, thisMonthIncrease from known

select @tolerance as tolerance, aa.sim, aa.serialid as candidate, bb.startyear, 
bb.startmonth, cc.total_mb as bill_mb,bb.total_mb as log_mb, 
cc.thisMonthIncrease as bill_percent, bb.thisMonthIncrease as log_percent, aa.counting
from
(
select a.sim, b.serialid,  count(a.sim)as counting

from orangebills_known_sim_percent_increase_temp  a,

known_serialid_billing_period_percent_increase_full_temp b
where
a.sim = @sim 
--ignore latest month when orangebills is not full
and 
	(
		a.startyear<2008 or a.startmonth<10 
	)
and 
	a.startyear=b.startyear and a.startmonth=b.startmonth
and
	(
		(a.thisMonthIncrease - b.thisMonthIncrease > -@tolerance)
		and 
		(a.thisMonthIncrease - b.thisMonthIncrease < @tolerance)	
	)
and 
	--the absolute value shouldn't be much different
	(
		(
		(b.total_mb<>0.0)
		and
		(a.total_MB/b.Total_MB < 1+@difference)
		and
		(a.total_MB/b.Total_MB > 1-@difference)
		)
		or 
		-- it wont matter if it is 0
		b.total_mb=0.0
	)
		

group by a.sim, b.serialid

having count(a.sim)>10
) aa,

orangebills_known_sim_percent_increase_temp cc,

known_serialid_billing_period_percent_increase_full_temp bb

where aa.serialid=bb.serialid and aa.sim=cc.sim and bb.startyear=cc.startyear and bb.startmonth=cc.startmonth
--ignore latest month when orangebills is not full
and 
	(
		bb.startyear<2008 or bb.startmonth<10 
	)

order by counting desc,bb.serialid, bb.startyear, bb.startmonth


